static const char *RcsId     = "$Header: /home/cvsadm/cvsroot/fermi/servers/a2505bs/src/A2505BSClass.cpp,v 1.2 2013-09-03 07:57:12 giulio Exp $";
static const char *TagName   = "$Name:  $";
static const char *HttpServer= "http://www.esrf.fr/computing/cs/tango/tango_doc/ds_doc/";
//+=============================================================================
//
// file :        A2505BSClass.cpp
//
// description : C++ source for the A2505BSClass. A singleton
//               class derived from DeviceClass. It implements the
//               command list and all properties and methods required
//               by the A2505BS once per process.
//
// project :     TANGO Device Server
//
// $Author: giulio $
//
// $Revision: 1.2 $
//
// $Log: A2505BSClass.cpp,v $
// Revision 1.2  2013-09-03 07:57:12  giulio
// Moved to Tango8 and Device4Impl
//
// Revision 1.1  2009-10-13 08:55:33  graziano
// first commit
//
// Revision 1.1  2007/12/12 11:44:38  enrico
// Release version. ME
//
//
// copyleft :   Sincrotrone Trieste S.C.p.A.
//              Strada Statale 14 - km 163,5 in AREA Science Park
//              34012 Basovizza, Trieste
//              ITALY
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================


#include <tango.h>

#include <A2505BS.h>
#include <A2505BSClass.h>


//+----------------------------------------------------------------------------
/**
 *	Create A2505BSClass singleton and return it in a C function for Python usage
 */
//+----------------------------------------------------------------------------
extern "C" {
#ifdef WIN32

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_A2505BS_class(const char *name) {
		return A2505BS_ns::A2505BSClass::init(name);
	}
}


namespace A2505BS_ns
{
//+----------------------------------------------------------------------------
//
// method : 		AbortClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *AbortClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "AbortClass::execute(): arrived" << endl;

	((static_cast<A2505BS *>(device))->abort());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		StartCyclingClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *StartCyclingClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "StartCyclingClass::execute(): arrived" << endl;

	((static_cast<A2505BS *>(device))->start_cycling());
	return new CORBA::Any();
}


//+----------------------------------------------------------------------------
//
// method : 		GetIDClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetIDClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetIDClass::execute(): arrived" << endl;

	return insert((static_cast<A2505BS *>(device))->get_id());
}

//+----------------------------------------------------------------------------
//
// method : 		OnCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *OnCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "OnCmd::execute(): arrived" << endl;

	((static_cast<A2505BS *>(device))->on());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		OffCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *OffCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "OffCmd::execute(): arrived" << endl;

	((static_cast<A2505BS *>(device))->off());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		GetCurrentCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetCurrentCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetCurrentCmd::execute(): arrived" << endl;

	return insert((static_cast<A2505BS *>(device))->get_current());
}

//+----------------------------------------------------------------------------
//
// method : 		GetVoltageCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetVoltageCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetVoltageCmd::execute(): arrived" << endl;

	return insert((static_cast<A2505BS *>(device))->get_voltage());
}

//+----------------------------------------------------------------------------
//
// method : 		GetDACValueCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetDACValueCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetDACValueCmd::execute(): arrived" << endl;

	return insert((static_cast<A2505BS *>(device))->get_dacvalue());
}

//+----------------------------------------------------------------------------
//
// method : 		GetReferenceCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetReferenceCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetReferenceCmd::execute(): arrived" << endl;

	return insert((static_cast<A2505BS *>(device))->get_reference());
}

//+----------------------------------------------------------------------------
//
// method : 		GetTemperatureCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetTemperatureCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetTemperatureCmd::execute(): arrived" << endl;

	return insert((static_cast<A2505BS *>(device))->get_temperature());
}

//+----------------------------------------------------------------------------
//
// method : 		GetPositiveRailCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetPositiveRailCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetPositiveRailCmd::execute(): arrived" << endl;

	return insert((static_cast<A2505BS *>(device))->get_positive_rail());
}

//+----------------------------------------------------------------------------
//
// method : 		GetStatusCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetStatusCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetStatusCmd::execute(): arrived" << endl;

	((static_cast<A2505BS *>(device))->get_status());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		ResetCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *ResetCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "ResetCmd::execute(): arrived" << endl;

	((static_cast<A2505BS *>(device))->reset());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		ModGlobStatClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *ModGlobStatClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "ModGlobStatClass::execute(): arrived" << endl;

	return insert((static_cast<A2505BS *>(device))->mod_glob_stat());
}

//+----------------------------------------------------------------------------
//
// method : 		DisableSwitcherCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *DisableSwitcherCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "DisableSwitcherCmd::execute(): arrived" << endl;

	return insert((static_cast<A2505BS *>(device))->disable_switcher());
}

//+----------------------------------------------------------------------------
//
// method : 		EnableSwitcherCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *EnableSwitcherCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "EnableSwitcherCmd::execute(): arrived" << endl;

	return insert((static_cast<A2505BS *>(device))->enable_switcher());
}

//+----------------------------------------------------------------------------
//
// method : 		ClearStatusCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *ClearStatusCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "ClearStatusCmd::execute(): arrived" << endl;

	return insert((static_cast<A2505BS *>(device))->clear_status());
}

//+----------------------------------------------------------------------------
//
// method : 		StandbyCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *StandbyCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "StandbyCmd::execute(): arrived" << endl;

	((static_cast<A2505BS *>(device))->standby());
	return new CORBA::Any();
}


//
//----------------------------------------------------------------
//	Initialize pointer for singleton pattern
//----------------------------------------------------------------
//
A2505BSClass *A2505BSClass::_instance = NULL;

//+----------------------------------------------------------------------------
//
// method : 		A2505BSClass::A2505BSClass(string &s)
// 
// description : 	constructor for the A2505BSClass
//
// in : - s : The class name
//
//-----------------------------------------------------------------------------
A2505BSClass::A2505BSClass(string &s):DeviceClass(s)
{

	cout2 << "Entering A2505BSClass constructor" << endl;
	set_default_property();
	write_class_property();
	get_class_property();
	
	cout2 << "Leaving A2505BSClass constructor" << endl;

}
//+----------------------------------------------------------------------------
//
// method : 		A2505BSClass::~A2505BSClass()
// 
// description : 	destructor for the A2505BSClass
//
//-----------------------------------------------------------------------------
A2505BSClass::~A2505BSClass()
{
	_instance = NULL;
}

//+----------------------------------------------------------------------------
//
// method : 		A2505BSClass::instance
// 
// description : 	Create the object if not already done. Otherwise, just
//			return a pointer to the object
//
// in : - name : The class name
//
//-----------------------------------------------------------------------------
A2505BSClass *A2505BSClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new A2505BSClass(s);
		}
		catch (bad_alloc)
		{
			throw;
		}		
	}		
	return _instance;
}

A2505BSClass *A2505BSClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}

//+----------------------------------------------------------------------------
//
// method : 		A2505BSClass::command_factory
// 
// description : 	Create the command object(s) and store them in the 
//			command list
//
//-----------------------------------------------------------------------------
void A2505BSClass::command_factory()
{
	command_list.push_back(new GetIDClass("GetID",
		Tango::DEV_VOID, Tango::DEV_STRING,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new OnCmd("On",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new OffCmd("Off",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetCurrentCmd("GetCurrent",
		Tango::DEV_VOID, Tango::DEV_DOUBLE,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetVoltageCmd("GetVoltage",
		Tango::DEV_VOID, Tango::DEV_DOUBLE,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetDACValueCmd("GetDACValue",
		Tango::DEV_VOID, Tango::DEV_DOUBLE,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetReferenceCmd("GetReference",
		Tango::DEV_VOID, Tango::DEV_DOUBLE,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetTemperatureCmd("GetTemperature",
		Tango::DEV_VOID, Tango::DEV_DOUBLE,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetPositiveRailCmd("GetPositiveRail",
		Tango::DEV_VOID, Tango::DEV_DOUBLE,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetStatusCmd("GetStatus",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new ResetCmd("Reset",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new ModGlobStatClass("ModGlobStat",
		Tango::DEV_VOID, Tango::DEV_STRING,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new DisableSwitcherCmd("DisableSwitcher",
		Tango::DEV_VOID, Tango::DEV_BOOLEAN,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new EnableSwitcherCmd("EnableSwitcher",
		Tango::DEV_VOID, Tango::DEV_BOOLEAN,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new ClearStatusCmd("ClearStatus",
		Tango::DEV_VOID, Tango::DEV_BOOLEAN,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new StandbyCmd("Standby",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new StartCyclingClass("StartCycling",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new AbortClass("Abort",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));

	//	add polling if any
	for (unsigned int i=0 ; i<command_list.size(); i++)
	{
	}
}

//+----------------------------------------------------------------------------
//
// method : 		A2505BSClass::get_class_property
// 
// description : 	Get the class property for specified name.
//
// in :		string	name : The property name
//
//+----------------------------------------------------------------------------
Tango::DbDatum A2505BSClass::get_class_property(string &prop_name)
{
	for (int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		A2505BSClass::get_default_device_property()
// 
// description : 	Return the default value for device property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum A2505BSClass::get_default_device_property(string &prop_name)
{
	for (int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//+----------------------------------------------------------------------------
//
// method : 		A2505BSClass::get_default_class_property()
// 
// description : 	Return the default value for class property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum A2505BSClass::get_default_class_property(string &prop_name)
{
	for (int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		A2505BSClass::device_factory
// 
// description : 	Create the device object(s) and store them in the 
//			device list
//
// in :		Tango::DevVarStringArray *devlist_ptr : The device name list
//
//-----------------------------------------------------------------------------
void A2505BSClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{

	//	Create all devices.(Automatic code generation)
	//-------------------------------------------------------------
	for (unsigned long i=0 ; i < devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
						
		// Create devices and add it into the device list
		//----------------------------------------------------
		device_list.push_back(new A2505BS(this, (*devlist_ptr)[i]));							 

		// Export device to the outside world
		// Check before if database used.
		//---------------------------------------------
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(device_list.back());
		else
			export_device(device_list.back(), (*devlist_ptr)[i]);
	}
	//	End of Automatic code generation
	//-------------------------------------------------------------

}
//+----------------------------------------------------------------------------
//	Method: A2505BSClass::attribute_factory(vector<Tango::Attr *> &att_list)
//-----------------------------------------------------------------------------
void A2505BSClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	//	Attribute : Voltage
	VoltageAttrib	*voltage = new VoltageAttrib();
	Tango::UserDefaultAttrProp	voltage_prop;
	voltage_prop.set_label("Voltage");
	voltage_prop.set_unit("V");
	voltage_prop.set_standard_unit("V");
	voltage_prop.set_display_unit("V");
	voltage_prop.set_format("%5.3f");
	voltage->set_default_properties(voltage_prop);
	att_list.push_back(voltage);

	//	Attribute : Temperature
	TemperatureAttrib	*temperature = new TemperatureAttrib();
	Tango::UserDefaultAttrProp	temperature_prop;
	temperature_prop.set_label("Temperature");
	temperature_prop.set_unit("C");
	temperature_prop.set_standard_unit("C");
	temperature_prop.set_display_unit("C");
	temperature_prop.set_format("%2.2f");
	temperature->set_default_properties(temperature_prop);
	att_list.push_back(temperature);

	//	Attribute : Current
	CurrentAttrib	*current = new CurrentAttrib();
	Tango::UserDefaultAttrProp	current_prop;
	current_prop.set_label("A");
	current_prop.set_unit("A");
	current_prop.set_standard_unit("A");
	current_prop.set_display_unit("A");
	current_prop.set_format("%5.3f");
	current->set_default_properties(current_prop);
	att_list.push_back(current);

	//	Attribute : PSStatus
	PSStatusAttrib	*psstatus = new PSStatusAttrib();
	Tango::UserDefaultAttrProp	psstatus_prop;
	psstatus_prop.set_label("Status mask");
	psstatus->set_default_properties(psstatus_prop);
	att_list.push_back(psstatus);

	//	Attribute : CurrentSetPoint
	CurrentSetPointAttrib	*current_set_point = new CurrentSetPointAttrib();
	Tango::UserDefaultAttrProp	current_set_point_prop;
	current_set_point_prop.set_label("CurSetPoint");
	current_set_point_prop.set_unit("A");
	current_set_point_prop.set_standard_unit("A");
	current_set_point_prop.set_display_unit("A");
	current_set_point_prop.set_format("%.3f");
	current_set_point->set_default_properties(current_set_point_prop);
	att_list.push_back(current_set_point);

	//	Attribute : ModelID
	ModelIDAttrib	*model_id = new ModelIDAttrib();
	Tango::UserDefaultAttrProp	model_id_prop;
	model_id_prop.set_label("PS Model ID");
	model_id->set_default_properties(model_id_prop);
	att_list.push_back(model_id);

}

//+----------------------------------------------------------------------------
//
// method : 		A2505BSClass::get_class_property()
// 
// description : 	Read the class properties from database.
//
//-----------------------------------------------------------------------------
void A2505BSClass::get_class_property()
{
	//	Initialize your default values here (if not done with  POGO).
	//------------------------------------------------------------------

	//	Read class properties from database.(Automatic code generation)
	//------------------------------------------------------------------

	//	Call database and extract values
	//--------------------------------------------
	if (Tango::Util::instance()->_UseDb==true)
		get_db_class()->get_property(cl_prop);
	Tango::DbDatum	def_prop;
	int	i = -1;


	//	End of Automatic code generation
	//------------------------------------------------------------------

}

//+----------------------------------------------------------------------------
//
// method : 	A2505BSClass::set_default_property
// 
// description: Set default property (class and device) for wizard.
//              For each property, add to wizard property name and description
//              If default value has been set, add it to wizard property and
//              store it in a DbDatum.
//
//-----------------------------------------------------------------------------
void A2505BSClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;

	vector<string>	vect_data;
	//	Set Default Class Properties
	//	Set Default Device Properties
	prop_name = "IpAddress";
	prop_desc = "IP address of power supply control device";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "TcpPort";
	prop_desc = "TCP port serving the power supply control device";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "StandbyCurrent";
	prop_desc = "Current imposed on standby command.";
	prop_def  = "0";
	vect_data.clear();
	vect_data.push_back("0");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "MaxCurr";
	prop_desc = "You guess. Max current value.";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "MinCurr";
	prop_desc = "You guess. Min current value.";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "CycMaxCurr";
	prop_desc = "";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "CycMinCurr";
	prop_desc = "";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "CycEndCurr";
	prop_desc = "";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "CycleWait";
	prop_desc = "milliseconds";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

}
//+----------------------------------------------------------------------------
//
// method : 		A2505BSClass::write_class_property
// 
// description : 	Set class description as property in database
//
//-----------------------------------------------------------------------------
void A2505BSClass::write_class_property()
{
	//	First time, check if database used
	//--------------------------------------------
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("Preinjector corrector PS");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("Tango device for the preinjector corrector power supply system (model A2505BS");
	description << str_desc;
	data.push_back(description);
		
	//	put cvs location
	string	rcsId(RcsId);
	string	filename(classname);
	start = rcsId.find("/");
	if (start!=string::npos)
	{
		filename += "Class.cpp";
		end   = rcsId.find(filename);
		if (end>start)
		{
			string	strloc = rcsId.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	//	Get CVS tag revision
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	//--------------------------------------------
	get_db_class()->put_property(data);
}

}	// namespace
